
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "applikation",
    "aufrufParameter",
    "inkarnationsTyp",
    "inkarnationsName",
    "initialize",
    "mitInkarnationsName",
    "startArt",
    "startBedingung",
    "startFehlerVerhalten",
    "stoppBedingung",
    "stoppFehlerVerhalten"
})
public class Inkarnation implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    private String applikation;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    private List<String> aufrufParameter = new ArrayList<String>();
    @JsonProperty("inkarnationsTyp")
    private Inkarnation.InkarnationsTyp inkarnationsTyp = Inkarnation.InkarnationsTyp.fromValue("dav");
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    private String inkarnationsName;
    @JsonProperty("initialize")
    private Boolean initialize = false;
    @JsonProperty("mitInkarnationsName")
    private Boolean mitInkarnationsName = true;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    private StartArt startArt;
    @JsonProperty("startBedingung")
    private StartBedingung startBedingung;
    @JsonProperty("startFehlerVerhalten")
    private StartFehlerVerhalten startFehlerVerhalten;
    @JsonProperty("stoppBedingung")
    private StoppBedingung stoppBedingung;
    @JsonProperty("stoppFehlerVerhalten")
    private StoppFehlerVerhalten stoppFehlerVerhalten;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = -122992741555406910L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Inkarnation() {
    }

    /**
     * 
     * @param inkarnationsTyp
     * @param applikation
     * @param aufrufParameter
     * @param stoppBedingung
     * @param inkarnationsName
     * @param startFehlerVerhalten
     * @param initialize
     * @param startArt
     * @param mitInkarnationsName
     * @param startBedingung
     * @param stoppFehlerVerhalten
     */
    public Inkarnation(String applikation, List<String> aufrufParameter, Inkarnation.InkarnationsTyp inkarnationsTyp, String inkarnationsName, Boolean initialize, Boolean mitInkarnationsName, StartArt startArt, StartBedingung startBedingung, StartFehlerVerhalten startFehlerVerhalten, StoppBedingung stoppBedingung, StoppFehlerVerhalten stoppFehlerVerhalten) {
        super();
        this.applikation = applikation;
        this.aufrufParameter = aufrufParameter;
        this.inkarnationsTyp = inkarnationsTyp;
        this.inkarnationsName = inkarnationsName;
        this.initialize = initialize;
        this.mitInkarnationsName = mitInkarnationsName;
        this.startArt = startArt;
        this.startBedingung = startBedingung;
        this.startFehlerVerhalten = startFehlerVerhalten;
        this.stoppBedingung = stoppBedingung;
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    public String getApplikation() {
        return applikation;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("applikation")
    public void setApplikation(String applikation) {
        this.applikation = applikation;
    }

    public Inkarnation withApplikation(String applikation) {
        this.applikation = applikation;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    public List<String> getAufrufParameter() {
        return aufrufParameter;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aufrufParameter")
    public void setAufrufParameter(List<String> aufrufParameter) {
        this.aufrufParameter = aufrufParameter;
    }

    public Inkarnation withAufrufParameter(List<String> aufrufParameter) {
        this.aufrufParameter = aufrufParameter;
        return this;
    }

    @JsonProperty("inkarnationsTyp")
    public Inkarnation.InkarnationsTyp getInkarnationsTyp() {
        return inkarnationsTyp;
    }

    @JsonProperty("inkarnationsTyp")
    public void setInkarnationsTyp(Inkarnation.InkarnationsTyp inkarnationsTyp) {
        this.inkarnationsTyp = inkarnationsTyp;
    }

    public Inkarnation withInkarnationsTyp(Inkarnation.InkarnationsTyp inkarnationsTyp) {
        this.inkarnationsTyp = inkarnationsTyp;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public String getInkarnationsName() {
        return inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public void setInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
    }

    public Inkarnation withInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
        return this;
    }

    @JsonProperty("initialize")
    public Boolean getInitialize() {
        return initialize;
    }

    @JsonProperty("initialize")
    public void setInitialize(Boolean initialize) {
        this.initialize = initialize;
    }

    public Inkarnation withInitialize(Boolean initialize) {
        this.initialize = initialize;
        return this;
    }

    @JsonProperty("mitInkarnationsName")
    public Boolean getMitInkarnationsName() {
        return mitInkarnationsName;
    }

    @JsonProperty("mitInkarnationsName")
    public void setMitInkarnationsName(Boolean mitInkarnationsName) {
        this.mitInkarnationsName = mitInkarnationsName;
    }

    public Inkarnation withMitInkarnationsName(Boolean mitInkarnationsName) {
        this.mitInkarnationsName = mitInkarnationsName;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    public StartArt getStartArt() {
        return startArt;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startArt")
    public void setStartArt(StartArt startArt) {
        this.startArt = startArt;
    }

    public Inkarnation withStartArt(StartArt startArt) {
        this.startArt = startArt;
        return this;
    }

    @JsonProperty("startBedingung")
    public StartBedingung getStartBedingung() {
        return startBedingung;
    }

    @JsonProperty("startBedingung")
    public void setStartBedingung(StartBedingung startBedingung) {
        this.startBedingung = startBedingung;
    }

    public Inkarnation withStartBedingung(StartBedingung startBedingung) {
        this.startBedingung = startBedingung;
        return this;
    }

    @JsonProperty("startFehlerVerhalten")
    public StartFehlerVerhalten getStartFehlerVerhalten() {
        return startFehlerVerhalten;
    }

    @JsonProperty("startFehlerVerhalten")
    public void setStartFehlerVerhalten(StartFehlerVerhalten startFehlerVerhalten) {
        this.startFehlerVerhalten = startFehlerVerhalten;
    }

    public Inkarnation withStartFehlerVerhalten(StartFehlerVerhalten startFehlerVerhalten) {
        this.startFehlerVerhalten = startFehlerVerhalten;
        return this;
    }

    @JsonProperty("stoppBedingung")
    public StoppBedingung getStoppBedingung() {
        return stoppBedingung;
    }

    @JsonProperty("stoppBedingung")
    public void setStoppBedingung(StoppBedingung stoppBedingung) {
        this.stoppBedingung = stoppBedingung;
    }

    public Inkarnation withStoppBedingung(StoppBedingung stoppBedingung) {
        this.stoppBedingung = stoppBedingung;
        return this;
    }

    @JsonProperty("stoppFehlerVerhalten")
    public StoppFehlerVerhalten getStoppFehlerVerhalten() {
        return stoppFehlerVerhalten;
    }

    @JsonProperty("stoppFehlerVerhalten")
    public void setStoppFehlerVerhalten(StoppFehlerVerhalten stoppFehlerVerhalten) {
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
    }

    public Inkarnation withStoppFehlerVerhalten(StoppFehlerVerhalten stoppFehlerVerhalten) {
        this.stoppFehlerVerhalten = stoppFehlerVerhalten;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Inkarnation withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("applikation", applikation).append("aufrufParameter", aufrufParameter).append("inkarnationsTyp", inkarnationsTyp).append("inkarnationsName", inkarnationsName).append("initialize", initialize).append("mitInkarnationsName", mitInkarnationsName).append("startArt", startArt).append("startBedingung", startBedingung).append("startFehlerVerhalten", startFehlerVerhalten).append("stoppBedingung", stoppBedingung).append("stoppFehlerVerhalten", stoppFehlerVerhalten).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(inkarnationsTyp).append(applikation).append(inkarnationsName).append(startBedingung).append(stoppFehlerVerhalten).append(aufrufParameter).append(stoppBedingung).append(startFehlerVerhalten).append(initialize).append(additionalProperties).append(startArt).append(mitInkarnationsName).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Inkarnation) == false) {
            return false;
        }
        Inkarnation rhs = ((Inkarnation) other);
        return new EqualsBuilder().append(inkarnationsTyp, rhs.inkarnationsTyp).append(applikation, rhs.applikation).append(inkarnationsName, rhs.inkarnationsName).append(startBedingung, rhs.startBedingung).append(stoppFehlerVerhalten, rhs.stoppFehlerVerhalten).append(aufrufParameter, rhs.aufrufParameter).append(stoppBedingung, rhs.stoppBedingung).append(startFehlerVerhalten, rhs.startFehlerVerhalten).append(initialize, rhs.initialize).append(additionalProperties, rhs.additionalProperties).append(startArt, rhs.startArt).append(mitInkarnationsName, rhs.mitInkarnationsName).isEquals();
    }

    public enum InkarnationsTyp {

        DAV("dav"),
        WRAPPED("wrapped"),
        EXTERN("extern");
        private final String value;
        private final static Map<String, Inkarnation.InkarnationsTyp> CONSTANTS = new HashMap<String, Inkarnation.InkarnationsTyp>();

        static {
            for (Inkarnation.InkarnationsTyp c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private InkarnationsTyp(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static Inkarnation.InkarnationsTyp fromValue(String value) {
            Inkarnation.InkarnationsTyp constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
