
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "inkarnationsName"
})
public class KernSystem implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    private String inkarnationsName;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 5508859599797416064L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public KernSystem() {
    }

    /**
     * 
     * @param inkarnationsName
     */
    public KernSystem(String inkarnationsName) {
        super();
        this.inkarnationsName = inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public String getInkarnationsName() {
        return inkarnationsName;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnationsName")
    public void setInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
    }

    public KernSystem withInkarnationsName(String inkarnationsName) {
        this.inkarnationsName = inkarnationsName;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public KernSystem withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("inkarnationsName", inkarnationsName).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(inkarnationsName).append(additionalProperties).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof KernSystem) == false) {
            return false;
        }
        KernSystem rhs = ((KernSystem) other);
        return new EqualsBuilder().append(inkarnationsName, rhs.inkarnationsName).append(additionalProperties, rhs.additionalProperties).isEquals();
    }

}
