
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "nachfolger",
    "rechner",
    "wartezeit"
})
public class StoppBedingung implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    private List<String> nachfolger = new ArrayList<String>();
    @JsonProperty("rechner")
    private String rechner;
    @JsonProperty("wartezeit")
    private String wartezeit;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 630552199889244899L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public StoppBedingung() {
    }

    /**
     * 
     * @param rechner
     * @param wartezeit
     * @param nachfolger
     */
    public StoppBedingung(List<String> nachfolger, String rechner, String wartezeit) {
        super();
        this.nachfolger = nachfolger;
        this.rechner = rechner;
        this.wartezeit = wartezeit;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    public List<String> getNachfolger() {
        return nachfolger;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("nachfolger")
    public void setNachfolger(List<String> nachfolger) {
        this.nachfolger = nachfolger;
    }

    public StoppBedingung withNachfolger(List<String> nachfolger) {
        this.nachfolger = nachfolger;
        return this;
    }

    @JsonProperty("rechner")
    public String getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(String rechner) {
        this.rechner = rechner;
    }

    public StoppBedingung withRechner(String rechner) {
        this.rechner = rechner;
        return this;
    }

    @JsonProperty("wartezeit")
    public String getWartezeit() {
        return wartezeit;
    }

    @JsonProperty("wartezeit")
    public void setWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
    }

    public StoppBedingung withWartezeit(String wartezeit) {
        this.wartezeit = wartezeit;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public StoppBedingung withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("nachfolger", nachfolger).append("rechner", rechner).append("wartezeit", wartezeit).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(rechner).append(additionalProperties).append(wartezeit).append(nachfolger).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof StoppBedingung) == false) {
            return false;
        }
        StoppBedingung rhs = ((StoppBedingung) other);
        return new EqualsBuilder().append(rechner, rhs.rechner).append(additionalProperties, rhs.additionalProperties).append(wartezeit, rhs.wartezeit).append(nachfolger, rhs.nachfolger).isEquals();
    }

}
