
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "name",
    "aenderungsgrund",
    "skript",
    "veranlasser",
    "passwort"
})
public class VersionierungsRequest implements Serializable
{

    @JsonProperty("name")
    private String name;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    private String aenderungsgrund;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    private StartStoppSkript skript;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    private String veranlasser;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    private String passwort;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 2239472997954457299L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public VersionierungsRequest() {
    }

    /**
     * 
     * @param passwort
     * @param skript
     * @param veranlasser
     * @param name
     * @param aenderungsgrund
     */
    public VersionierungsRequest(String name, String aenderungsgrund, StartStoppSkript skript, String veranlasser, String passwort) {
        super();
        this.name = name;
        this.aenderungsgrund = aenderungsgrund;
        this.skript = skript;
        this.veranlasser = veranlasser;
        this.passwort = passwort;
    }

    @JsonProperty("name")
    public String getName() {
        return name;
    }

    @JsonProperty("name")
    public void setName(String name) {
        this.name = name;
    }

    public VersionierungsRequest withName(String name) {
        this.name = name;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    public String getAenderungsgrund() {
        return aenderungsgrund;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("aenderungsgrund")
    public void setAenderungsgrund(String aenderungsgrund) {
        this.aenderungsgrund = aenderungsgrund;
    }

    public VersionierungsRequest withAenderungsgrund(String aenderungsgrund) {
        this.aenderungsgrund = aenderungsgrund;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    public StartStoppSkript getSkript() {
        return skript;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("skript")
    public void setSkript(StartStoppSkript skript) {
        this.skript = skript;
    }

    public VersionierungsRequest withSkript(StartStoppSkript skript) {
        this.skript = skript;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    public String getVeranlasser() {
        return veranlasser;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("veranlasser")
    public void setVeranlasser(String veranlasser) {
        this.veranlasser = veranlasser;
    }

    public VersionierungsRequest withVeranlasser(String veranlasser) {
        this.veranlasser = veranlasser;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    public String getPasswort() {
        return passwort;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("passwort")
    public void setPasswort(String passwort) {
        this.passwort = passwort;
    }

    public VersionierungsRequest withPasswort(String passwort) {
        this.passwort = passwort;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public VersionierungsRequest withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this).append("name", name).append("aenderungsgrund", aenderungsgrund).append("skript", skript).append("veranlasser", veranlasser).append("passwort", passwort).append("additionalProperties", additionalProperties).toString();
    }

    @Override
    public int hashCode() {
        return new HashCodeBuilder().append(passwort).append(skript).append(veranlasser).append(name).append(aenderungsgrund).append(additionalProperties).toHashCode();
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof VersionierungsRequest) == false) {
            return false;
        }
        VersionierungsRequest rhs = ((VersionierungsRequest) other);
        return new EqualsBuilder().append(passwort, rhs.passwort).append(skript, rhs.skript).append(veranlasser, rhs.veranlasser).append(name, rhs.name).append(aenderungsgrund, rhs.aenderungsgrund).append(additionalProperties, rhs.additionalProperties).isEquals();
    }

}
